<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2//EN">
<HTML>
<HEAD>
	<META HTTP-EQUIV="CONTENT-TYPE" CONTENT="text/html; charset=utf-8">
	<TITLE>Transformation implementation in ATL</TITLE>
	<META NAME="GENERATOR" CONTENT="OpenOffice.org 2.2  (Linux)">
	<META NAME="CREATED" CONTENT="20070928;11000900">
	<META NAME="CHANGEDBY" CONTENT="Vincent Mahe">
	<META NAME="CHANGED" CONTENT="20070928;11000900">
</HEAD>
<BODY LANG="fr-FR" BGCOLOR="#ffffff" DIR="LTR">
<H1><FONT FACE="Nimbus Sans L"><FONT SIZE=5>Transformation
implementation in ATL</FONT></FONT></H1>
<H2><FONT FACE="Nimbus Sans L"><FONT SIZE=4><I>The declarative way</I></FONT></FONT></H2>
<P>In this example, we want to match to the main ATL philosophy as
much as we can. I.e, we'll avoid to use any <B>called rules</B> in
our code.</P>
<P>In our transformation, we clearly see the creation of two matched
rules :</P>
<UL>
	<LI><P>“Tree-Root” (a “non contained <I>Node</I>”) To
	<I>MMElementList!RootElement</I></P>
	<LI><P><I>MMTree!Leaf</I>  To <I>MMElementList!CommonElement</I></P>
</UL>
<P>However it is important to note 
</P>
<UL>
	<LI><P>the leaves order is critical to our transformation. Hence,
	the leaves transformation is closely linked to its position in the
	“<I>children</I>” attribute of a <I>MMTree!Node</I></P>
</UL>
<UL>
	<LI><P>the <I>MMTree!Leaf</I>  elements are kept into the
	containment attribute of a <I>MMTree!Node</I>, hence the
	transformation will have to use ATL <B>traceability links</B> (which
	avoid us to use the <B>distinct</B> keyword)</P>
</UL>
<P>In order to compute the leaves order, we plan to create :</P>
<UL>
	<LI><P>a <I>getAllChildren</I> (recursive) helper which returns all
	<I>TreeElement</I> encountered during the DFS</P>
	<LI><P>a <I>getLeavesInOrder</I> helper which uses the list returned
	by a call to <I>getAllChildren</I> to retrieve then filter and sort
	all leaves in the needed order : let “<I>leaves”</I> being the
	returned list of leaves, we compute a 3 set partition <I>of leaves </I>:<I>
	</I>one “big leaves” list, one “medium leaves” list and one
	“small leaves” list. We then make an <B>union</B> of these 3
	lists which gives us the well ordered leave list used by the
	<B>traceability link</B> transforming each Leaf into an Element.</P>
</UL>
<H2><FONT FACE="Nimbus Sans L"><FONT SIZE=4><I>The launcher</I></FONT></FONT></H2>
<P>The launcher configuration is pretty common as both meta models
have been created with the EMF Ecore plugin. There is no library and
no superimposed module.</P>
<P>As a sidenote, the &laquo;&nbsp;Tree&nbsp;&raquo; model instance
matching the example in this paper is available in the
&laquo;&nbsp;modelinstances&nbsp;&raquo; directory of the
&laquo;&nbsp;fr.cs.leplessis.example.tree&nbsp;&raquo; project. The
resulting &laquo;&nbsp;List&nbsp;&raquo; model instance should be
located in the &laquo;&nbsp;modelinstances&nbsp;&raquo; directory of
the &laquo;&nbsp;fr.cs.leplessis.example.list&nbsp;&raquo; project.</P>
</BODY>
</HTML>